<?php
/**
 * MyBB 1.6
 * Copyright 2012 My-BB.Ir Group, All Rights Reserved
 *
 * Website: http://my-bb.ir
 *
 * $Id: mybbirjalalidate.php AliReza_Tofighi $
 */
 
// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook("my_date", "mybbirjalalidate");
$plugins->add_hook("member_profile_end", "mybbirjalalidateprofile");
$plugins->add_hook("index_end", "jalali_bdays_index");
function mybbirjalalidate_info()
{
	return array(
		"name"			=> "تاریخ شمسی (تاریخ جلالی برای وب سایت)",
		"description"	=> "با استفاده از این پلاگین می توانید تاریخ انجمن خود را به تاریخ شمسی یا جلالی تبدیل کنید.",
		"website"		=> "http://my-bb.ir",
		"author"		=> "AliReza_Tofighi",
		"authorsite"	=> "http://my-bb.ir",
		"version"		=> "0.38",
		"guid" 			=> "",
		"compatibility" => "*"
	);
}


function mybbirjalalidate_activate(){}

function mybbirjalalidate_deactivate(){}
function jalali_bdays_index() {
	foreach($GLOBALS as $key => $val)
	{
		global $$key;
	}
	$logoutlink = $loginform = '';
	if($mybb->user['uid'] != 0)
	{
		eval("\$logoutlink = \"".$templates->get("index_logoutlink")."\";");
	}
	else
	{
		//Checks to make sure the user can login; they haven't had too many tries at logging in.
		//Function call is not fatal
		if(login_attempt_check(false) !== false)
		{
			switch($mybb->settings['username_method'])
			{
				case 0:
					$login_username = $lang->login_username;
					break;
				case 1:
					$login_username = $lang->login_username1;
					break;
				case 2:
					$login_username = $lang->login_username2;
					break;
				default:
					$login_username = $lang->login_username;
					break;
			}
			eval("\$loginform = \"".$templates->get("index_loginform")."\";");
		}
	}
	$whosonline = '';
	if($mybb->settings['showwol'] != 0 && $mybb->usergroup['canviewonline'] != 0)
	{
		// Get the online users.
		$timesearch = TIME_NOW - $mybb->settings['wolcutoff'];
		$comma = '';
		$query = $db->query("
			SELECT s.sid, s.ip, s.uid, s.time, s.location, s.location1, u.username, u.invisible, u.usergroup, u.displaygroup
			FROM ".TABLE_PREFIX."sessions s
			LEFT JOIN ".TABLE_PREFIX."users u ON (s.uid=u.uid)
			WHERE s.time>'$timesearch'
			ORDER BY u.username ASC, s.time DESC
		");

		$forum_viewers = array();
		$membercount = 0;
		$onlinemembers = '';
		$guestcount = 0;
		$anoncount = 0;
		$doneusers = array();

		// Fetch spiders
		$spiders = $cache->read("spiders");

		// Loop through all users.
		while($user = $db->fetch_array($query))
		{
			// Create a key to test if this user is a search bot.
			$botkey = my_strtolower(str_replace("bot=", '', $user['sid']));

			// Decide what type of user we are dealing with.
			if($user['uid'] > 0)
			{
				// The user is registered.
				if($doneusers[$user['uid']] < $user['time'] || !$doneusers[$user['uid']])
				{
					// If the user is logged in anonymously, update the count for that.
					if($user['invisible'] == 1)
					{
						++$anoncount;
					}
					++$membercount;
					if($user['invisible'] != 1 || $mybb->usergroup['canviewwolinvis'] == 1 || $user['uid'] == $mybb->user['uid'])
					{
						// If this usergroup can see anonymously logged-in users, mark them.
						if($user['invisible'] == 1)
						{
							$invisiblemark = "*";
						}
						else
						{
							$invisiblemark = '';
						}

						// Properly format the username and assign the template.
						$user['username'] = format_name($user['username'], $user['usergroup'], $user['displaygroup']);
						$user['profilelink'] = build_profile_link($user['username'], $user['uid']);
						eval("\$onlinemembers .= \"".$templates->get("index_whosonline_memberbit", 1, 0)."\";");
						$comma = $lang->comma;
					}
					// This user has been handled.
					$doneusers[$user['uid']] = $user['time'];
				}
			}
			elseif(my_strpos($user['sid'], "bot=") !== false && $spiders[$botkey])
			{
				// The user is a search bot.
				$onlinemembers .= $comma.format_name($spiders[$botkey]['name'], $spiders[$botkey]['usergroup']);
				$comma = $lang->comma;
				++$botcount;
			}
			else
			{
				// The user is a guest.
				++$guestcount;
			}

			if($user['location1'])
			{
				$forum_viewers[$user['location1']]++;
			}
		}

		// Build the who's online bit on the index page.
		$onlinecount = $membercount + $guestcount + $botcount;
		
		if($onlinecount != 1)
		{
			$onlinebit = $lang->online_online_plural;
		}
		else
		{
			$onlinebit = $lang->online_online_singular;
		}
		if($membercount != 1)
		{
			$memberbit = $lang->online_member_plural;
		}
		else
		{
			$memberbit = $lang->online_member_singular;
		}
		if($anoncount != 1)
		{
			$anonbit = $lang->online_anon_plural;
		}
		else
		{
			$anonbit = $lang->online_anon_singular;
		}
		if($guestcount != 1)
		{
			$guestbit = $lang->online_guest_plural;
		}
		else
		{
			$guestbit = $lang->online_guest_singular;
		}
		$lang->online_note = $lang->sprintf($lang->online_note, my_number_format($onlinecount), $onlinebit, $mybb->settings['wolcutoffmins'], my_number_format($membercount), $memberbit, my_number_format($anoncount), $anonbit, my_number_format($guestcount), $guestbit);
		eval("\$whosonline = \"".$templates->get("index_whosonline")."\";");
	}

	// Build the birthdays for to show on the index page.
	$bdays = $birthdays = '';
	if($mybb->settings['showbirthdays'] != 0)
	{
		// First, see what day this is.
		$bdaycount = 0; $bdayhidden = 0;
		$bdaytime = TIME_NOW;
		$bdaydate = gregorian_date("j-n", $bdaytime, '', 0);
		$year = gregorian_date("Y", $bdaytime, '', 0);
		
		$bdaycache = $cache->read("birthdays");
		
		if(!is_array($bdaycache))
		{
			$cache->update_birthdays();
			$bdaycache = $cache->read("birthdays");
		}
		
		$hiddencount = $bdaycache[$bdaydate]['hiddencount'];
		$today_bdays = $bdaycache[$bdaydate]['users'];

		$comma = '';
		if(!empty($today_bdays))
		{
			if(intval($mybb->settings['showbirthdayspostlimit']) > 0)
			{
				$bdayusers = array();
				foreach($today_bdays as $key => $bdayuser_pc)
				{
					$bdayusers[$bdayuser_pc['uid']] = $key;
				}

				if(!empty($bdayusers))
				{
					// Find out if our users have enough posts to be seen on our birthday list
					$bday_sql = implode(",", array_keys($bdayusers));
					$query = $db->simple_select("users", "uid, postnum", "uid IN ({$bday_sql})");

					while($bdayuser = $db->fetch_array($query))
					{
						if($bdayuser['postnum'] < $mybb->settings['showbirthdayspostlimit'])
						{
							unset($today_bdays[$bdayusers[$bdayuser['uid']]]);
						}
					}
				}
			}

			// We still have birthdays - display them in our list!
			if(!empty($today_bdays))
			{
				foreach($today_bdays as $bdayuser)
				{
					if($bdayuser['displaygroup'] == 0)
					{
						$bdayuser['displaygroup'] = $bdayuser['usergroup'];
					}

					// If this user's display group can't be seen in the birthday list, skip it
					if($groupscache[$bdayuser['displaygroup']] && $groupscache[$bdayuser['displaygroup']]['showinbirthdaylist'] != 1)
					{
						continue;
					}

					$bday = explode("-", $bdayuser['birthday']);
					if($year > $bday['2'] && $bday['2'] != '')
					{
						$age = " (".($year - $bday['2']).")";
					}
					else
					{
						$age = '';
					}

					$bdayuser['username'] = format_name($bdayuser['username'], $bdayuser['usergroup'], $bdayuser['displaygroup']);
					$bdayuser['profilelink'] = build_profile_link($bdayuser['username'], $bdayuser['uid']);
					eval("\$bdays .= \"".$templates->get("index_birthdays_birthday", 1, 0)."\";");
					++$bdaycount;
					$comma = $lang->comma;
				}
			}
		}

		if($hiddencount > 0)
		{
			if($bdaycount > 0)
			{
				$bdays .= " - ";
			}
			$bdays .= "{$hiddencount} {$lang->birthdayhidden}";
		}
		
		// If there are one or more birthdays, show them.
		if($bdaycount > 0 || $hiddencount > 0)
		{
			eval("\$birthdays = \"".$templates->get("index_birthdays")."\";");
		}
	}

	// Build the forum statistics to show on the index page.
	if($mybb->settings['showindexstats'] != 0)
	{
		// First, load the stats cache.
		$stats = $cache->read("stats");

		// Check who's the newest member.
		if(!$stats['lastusername'])
		{
			$newestmember = "no-one";
		}
		else
		{
			$newestmember = build_profile_link($stats['lastusername'], $stats['lastuid']);
		}

		// Format the stats language.
		$lang->stats_posts_threads = $lang->sprintf($lang->stats_posts_threads, my_number_format($stats['numposts']), my_number_format($stats['numthreads']));
		$lang->stats_numusers = $lang->sprintf($lang->stats_numusers, my_number_format($stats['numusers']));
		$lang->stats_newestuser = $lang->sprintf($lang->stats_newestuser, $newestmember);

		// Find out what the highest users online count is.
		$mostonline = $cache->read("mostonline");
		if($onlinecount > $mostonline['numusers'])
		{
			$time = TIME_NOW;
			$mostonline['numusers'] = $onlinecount;
			$mostonline['time'] = $time;
			$cache->update("mostonline", $mostonline);
		}
		$recordcount = $mostonline['numusers'];
		$recorddate = my_date($mybb->settings['dateformat'], $mostonline['time']);
		$recordtime = my_date($mybb->settings['timeformat'], $mostonline['time']);

		// Then format that language string.
		$lang->stats_mostonline = $lang->sprintf($lang->stats_mostonline, my_number_format($recordcount), $recorddate, $recordtime);

		eval("\$forumstats = \"".$templates->get("index_stats")."\";");
	}

	// Show the board statistics table only if one or more index statistics are enabled.
	if(($mybb->settings['showwol'] != 0 && $mybb->usergroup['canviewonline'] != 0) || $mybb->settings['showindexstats'] != 0 || ($mybb->settings['showbirthdays'] != 0 && $bdaycount > 0))
	{
		if(!is_array($stats))
		{
			// Load the stats cache.
			$stats = $cache->read("stats");
		}

		$post_code_string = '';
		if($mybb->user['uid'])
		{
			$post_code_string = "&amp;my_post_key=".$mybb->post_code;
		}

		eval("\$boardstats = \"".$templates->get("index_boardstats")."\";");
	}
}
function jalali_get_age($birthday)
{
	$bday = explode("-", $birthday);
	$c = new jCalendar;
	list($bday[2], $bday[1], $bday[0]) = $c->gregorian_to_jalali($bday[2], $bday[1], $bday[0]);
	if(!$bday[2])
	{
		return;
	}

	list($day, $month, $year) = explode("-", my_date("j-n-Y", TIME_NOW, 0, 0));
	$age = $year-$bday[2];

	if(($month == $bday[1] && $day < $bday[0]) || $month < $bday[1])
	{
		--$age;
	}
	return $age;
}


function mybbirjalalidateprofile() {
	global $mybb, $lang, $memprofile, $membday, $bdayformat, $membdayage;
	if($memprofile['birthday'])
	{
		$membday = explode("-", $memprofile['birthday']);
		$c = new jCalendar;
		//echo $membday[0];
		list($membday[2], $membday[1], $membday[0]) = $c->gregorian_to_jalali($membday[2], $membday[1], $membday[0]);
		if($memprofile['birthdayprivacy'] != 'none')
		{
			if($membday[0] && $membday[1] && $membday[2])
			{
				$lang->membdayage = $lang->sprintf($lang->membdayage, jalali_get_age($memprofile['birthday']));
				
				if($membday[2] >= 1300)
				{
					$w_day = $c->date("l", mktime(0, 0, 0, $membday[1], $membday[0], $membday[2]));
					$membday = format_bdays($mybb->settings['dateformat'], $membday[1], $membday[0], $membday[2], $w_day);
				}
				else
				{
					$bdayformat = fix_mktime($mybb->settings['dateformat'], $membday[2]);
					$membday = $c->mktime(0, 0, 0, $membday[1], $membday[0], $membday[2]);
					$membday = $c->date($bdayformat, $membday);
				}
				$age = jalali_get_age($memprofile['birthday']);
				$agemiladi = get_age($memprofile['birthday']);
				$membdayage = str_replace($agemiladi, $age, $lang->membdayage);
			}
			elseif($membday[2])
			{
				$membday = $c->mktime(0, 0, 0, 1, 1, $membday[2]);
				$membday = $c->date("Y", $membday);
				$membdayage = '';
			}
			else
			{
				$membday = $c->mktime(0, 0, 0, $membday[1], $membday[0], 0);
				$membday = $c->date("F j", $membday);
				$membdayage = '';
			}
		}
		
		if($memprofile['birthdayprivacy'] == 'age')
		{
			$membday = $lang->birthdayhidden;
		}
		else if($memprofile['birthdayprivacy'] == 'none')
		{
			$membday = $lang->birthdayhidden;
			$membdayage = '';
		}
	}
	else
	{
		$membday = $lang->not_specified;
		$membdayage = '';
	}
}

function mybbirjalalidate(&$date)
{
	global $mybb, $mybbadmin;
	$c = new jCalendar;
	$c->farsiDigits = false;
	foreach (debug_backtrace() as $debug_backtrace)
	{
		if ($debug_backtrace['function'] == "my_date")
		{
			$format = $debug_backtrace['args'][0];
			$timestamp = $debug_backtrace['args'][1];
			$offset = $debug_backtrace['args'][2];
			if(!$offset && $offset != '0')
			{
				if($mybb->user['uid'] != 0 && array_key_exists("timezone", $mybb->user))
				{
					$offset = $mybb->user['timezone'];
					$dstcorrection = $mybb->user['dst'];
				}
				elseif(defined("IN_ADMINCP"))
				{
					$offset =  $mybbadmin['timezone'];
					$dstcorrection = $mybbadmin['dst'];
				}
				else
				{
					$offset = $mybb->settings['timezoneoffset'];
					$dstcorrection = $mybb->settings['dstcorrection'];
				}

				// If DST correction is enabled, add an additional hour to the timezone.
				if($dstcorrection == 1)
				{
					++$offset;
					if(my_substr($offset, 0, 1) != "-")
					{
						$offset = "+".$offset;
					}
				}
			}

			if($offset == "-")
			{
				$offset = 0;
			}
			$offset = $offset*3600;
			$date = $c->gmdate($format, $timestamp, $offset);
		}
	}
}

function gregorian_date($format, $stamp="", $offset="", $ty=1, $adodb=false)
{
	global $mybb, $lang, $mybbadmin, $plugins;

	// If the stamp isn't set, use TIME_NOW
	if(empty($stamp))
	{
		$stamp = TIME_NOW;
	}

	if(!$offset && $offset != '0')
	{
		if($mybb->user['uid'] != 0 && array_key_exists("timezone", $mybb->user))
		{
			$offset = $mybb->user['timezone'];
			$dstcorrection = $mybb->user['dst'];
		}
		elseif(defined("IN_ADMINCP"))
		{
			$offset =  $mybbadmin['timezone'];
			$dstcorrection = $mybbadmin['dst'];
		}
		else
		{
			$offset = $mybb->settings['timezoneoffset'];
			$dstcorrection = $mybb->settings['dstcorrection'];
		}

		// If DST correction is enabled, add an additional hour to the timezone.
		if($dstcorrection == 1)
		{
			++$offset;
			if(my_substr($offset, 0, 1) != "-")
			{
				$offset = "+".$offset;
			}
		}
	}

	if($offset == "-")
	{
		$offset = 0;
	}
	
	if($adodb == true && function_exists('adodb_date'))
	{
		$date = adodb_date($format, $stamp + ($offset * 3600));
	}
	else
	{
		$date = gmdate($format, $stamp + ($offset * 3600));
	}
	
	if($mybb->settings['dateformat'] == $format && $ty)
	{
		$stamp = TIME_NOW;
		
		if($adodb == true && function_exists('adodb_date'))
		{
			$todaysdate = adodb_date($format, $stamp + ($offset * 3600));
			$yesterdaysdate = adodb_date($format, ($stamp - 86400) + ($offset * 3600));
		}
		else
		{
			$todaysdate = gmdate($format, $stamp + ($offset * 3600));
			$yesterdaysdate = gmdate($format, ($stamp - 86400) + ($offset * 3600));
		}

		if($todaysdate == $date)
		{
			$date = $lang->today;
		}
		else if($yesterdaysdate == $date)
		{
			$date = $lang->yesterday;
		}
	}

	return $date;
}

Class jCalendar {
	/**
	 * Assoc array, container of all date chars
	*/
	public $format = array();
	/**
	 * Assoc array, container of all jdate chars
	*/
	public $jformat = array();
	/**
	 * Use Farsi digits on output.
	*/
	public $farsiDigits = true;
	
	
	
	/**
	 * PHP::getdate() in Jalali result
	 *
	 * @param $timestamp int  Unix Timestamp
	 * @return array Date data on standard getdate result array
	*/
	public function getdate($timestamp=null) {
		$timestamp = $timestamp===null ? time() : $timestamp;
		$this->jdate('', $timestamp);
		$getDate = getdate($timestamp);
		$getDate['mday'] = $this->jformat['j']; $getDate['wday'] = $this->jformat['w'];
		$getDate['mon'] = $this->jformat['n']; $getDate['year'] = $this->jformat['Y'];
		$getDate['yday'] = $this->jformat['z']; $getDate['weekday'] = $this->jformat['l'];
		$getDate['month'] = $this->jformat['F'];
		foreach($getDate as $key => $value) $getDate[$key] = $this->translateDigits($value);
		$getDate[0] = $timestamp;
		return $getDate;
	}
	
	
	
	/**
	 * PHP::mktime() by Jalali inputs
	 *
	 * @param $hour int  Standard hour
	 * @param $minute int  Standard minute
	 * @param $second int  Standard second
	 * @param $month int  Standard Jalali month
	 * @param $day int  Standard Jalali day number
	 * @param $year int  Standard Jalali year
	 * @return int Unix Timestamp (GREGORIAN)
	*/
	public function mktime($hour=null, $minute=null, $second=null, $month=null, $day=null, $year=null) {
		$this->jdate('Y');
		$year = $year===null ? $this->jformat['Y'] : $year;
		$month = $month===null ? $this->jformat['n'] : $month;
		$day = $day===null ? $this->jformat['j'] : $day;
		$hour = $hour===null ? $this->jformat['h'] : $hour;
		$minute = $minute===null ? $this->jformat['i'] : $minute;
		$second = $second===null ? $this->jformat['s'] : $second;
		list($year, $month, $day) = $this->jalali_to_gregorian($year, $month, $day);
		return mktime($hour, $minute, $second, $month, $day, $year);
	}
	
	
	
	/**
	 * PHP::date() by Jalali result
	 *
	 * @param $format string  Standard PHP::date() format
	 * @param $stamp int  Unix Timestamp
	 * @param $GMT int  Difference to server time in seconds
	 * @return string Converted input
	*/
	public function date($format, $stamp=null, $GMT=null) {
		$GMT = isset($GMT) ? $GMT : date("Z");
		$stamp = isset($stamp) ? ($stamp+$GMT) : (time()+$GMT);
		
		$formatArr = array(
			'd', 'D', 'j', 'l', 'N', 'S', 'w', 'z', 'W', 'F', 'm', 'M', 'n', 't', 'L', 'o', 'Y', 'y',
			'a','A', 'B', 'g', 'G', 'h', 'H', 'i', 's', 'u', 'e', 'I', 'O', 'P', 'T', 'Z', 'c', 'r', 'U'
		);
		$fullFormat = explode("|", date(join("|", $formatArr), $stamp) );
		$count = count($formatArr);
		for($i=0; $i<$count; $i++) $this->format[$formatArr[$i]] = $fullFormat[$i];
		
		// Y
		list($this->jformat['Y'], $this->jformat['m'], $this->jformat['d']) = $this->gregorian_to_jalali($this->format['Y'], $this->format['m'], $this->format['d']);
		// a
		$this->jformat['a'] = ($this->format['a']=="pm") ? "ب.ظ" : "ق.ظ";
		// A
		$this->jformat['A'] = ($this->format['A']=="PM") ? "ب.ظ" : "ق.ظ";
		// B
		$this->jformat['B'] = $this->format['B'];
		// D
		switch ( strtolower($this->format['D']) ) {
			case "sat" : $this->jformat['D'] = "ش"; break; case "sun" : $this->jformat['D'] = "ی"; break;
			case "mon" : $this->jformat['D'] = "د"; break; case "tue" : $this->jformat['D'] = "س"; break;
			case "wed" : $this->jformat['D'] = "چ"; break; case "thu" : $this->jformat['D'] = "پ"; break;
			case "fri" : $this->jformat['D'] = "ج"; break;
		}
		// F
		$this->jformat['F'] = $this->ReturnMonthName($this->jformat['m']);
		// h
		$this->jformat['h'] = $this->format['h'];
		// H
		$this->jformat['H'] = $this->format['H'];
		// g
		$this->jformat['g'] = $this->format['g'];
		// G
		$this->jformat['G'] = $this->format['G'];
		// i
		$this->jformat['i'] = $this->format['i'];
		// j
		$this->jformat['j'] = $this->jformat['d'];
		// d
		$this->jformat['d'] = ($this->jformat['d'] < 10) ? "0".$this->jformat['d'] : $this->jformat['d'];
		// l
		switch ( strtolower($this->format['l']) ) {
			case "saturday" : $this->jformat['l'] = "شنبه"; break;
			case "sunday" : $this->jformat['l'] = "یکشنبه"; break;
			case "monday" : $this->jformat['l'] = "دوشنبه"; break;
			case "tuesday" : $this->jformat['l'] = "سه شنبه"; break;
			case "wednesday" : $this->jformat['l'] = "چهارشنبه"; break;
			case "thursday" : $this->jformat['l'] = "پنجشنبه"; break;
			case "friday" : $this->jformat['l'] = "جمعه"; break;
		}
		// L
		$ka = date("L", (time()-31536000)); // previous Gregorian year
		$this->jformat['L'] = ($ka==1) ? 1 : 0;
		// n
		$this->jformat['n'] = $this->jformat['m'];
		// m
		$this->jformat['m'] = ($this->jformat['m'] < 10) ? "0".$this->jformat['m'] : $this->jformat['m'];
		// M
		$this->jformat['M'] = $this->jformat['F'];
		// N
		switch ( strtolower($this->format['l']) ) {
			case "saturday" : $this->jformat['N'] = 1; break;
			case "sunday" : $this->jformat['N'] = 2; break;
			case "monday" : $this->jformat['N'] = 3; break;
			case "tuesday" : $this->jformat['N'] = 4; break;
			case "wednesday" : $this->jformat['N'] = 5; break;
			case "thursday" : $this->jformat['N'] = 6; break;
			case "friday" : $this->jformat['N'] = 7; break;
		}
		// o
		$this->jformat['o'] = $this->jformat['Y'];
		// w
		$this->jformat['w'] = $this->jformat['N'] - 1;
		// t
		$this->jformat['t'] = ($this->jformat['m'] <= 6) ? 31 : 30;
		$this->jformat['t'] = ($this->jformat['m'] == 12) ? ($this->jformat['L'] == 1 ? 30 : 29) : $this->jformat['t'];
		// s
		$this->jformat['s'] = $this->format['s'];
		// S
		$this->jformat['S'] = "ام";
		// e
		$this->jformat['e'] = $this->format['e'];
		// I
		$this->jformat['I'] =$this->format['I'];
		// u
		$this->jformat['u'] = $this->format['u'];
		// U
		$this->jformat['U'] = $this->format['U'];
		// y
		$this->jformat['y'] = $this->jformat['Y']%100;
		// Z
		$this->jformat['Z'] = $this->format['Z'];
		// z
		if($this->jformat['n'] > 6) $this->jformat['z'] = 186 + (($this->jformat['n'] - 6 - 1) * 30) + $this->jformat['j'];
		else $this->jformat['z'] = (($this->jformat['n'] - 1) * 31) + $this->jformat['j'];
		// W
		$this->jformat['W'] = is_integer($this->jformat['z'] / 7) ? ($this->jformat['z'] / 7) : ($this->jformat['z'] / 7 + 1);
		// r
		$positive_z = abs(($this->jformat['Z'])/3600);
		if($positive_z > 1) {
			$z_hour = ((int) $positive_z < 10 ? "0" : "") . (int) $positive_z;
			$z_minute = (($positive_z - $z_hour) * 60 < 10 ? "0" : "") . ($positive_z - $z_hour) * 60;
		} else {
			$z_hour = "00";
			$z_minute = (($positive_z) * 60 < 10 ? "0" : "") . ($positive_z) * 60;
		}
		// P
		$this->jformat['P'] = ($this->jformat['Z'] >= 0 ? "+" : "-") . "$z_hour:$z_minute";
		// O
		$this->jformat['O'] = ($this->jformat['Z'] >= 0 ? "+" : "-") . $z_hour . $z_minute;
		// c
		$this->jformat['c'] = $this->jformat['Y'] ."-". $this->jformat['m'] ."-". $this->jformat['d'] ."-". $this->jformat['H'] ." ". $this->jformat['i'] . ":" . $this->jformat['s']. $this->jformat['P'];
		// r
		$this->jformat['r'] = $this->jformat['l'] ." ". $this->jformat['j'] ." ". $this->jformat['F'] ." ". $this->jformat['Y'] ." ". $this->jformat['h'] . ":" . $this->jformat['i'] . ":" . $this->jformat['s'] ." ". $this->jformat['O'];		
		// T
		$this->jformat['T'] = $this->format['T'];
		foreach($formatArr as $key) $format = str_replace($key, $this->jformat[$key], $format);
		return $this->translateDigits($format);
	}
	
	/**
	 * PHP::gmdate() by Jalali result
	 *
	 * @param $format string  Standard PHP::gmdate() format
	 * @param $stamp int  Unix Timestamp
	 * @param $GMT int  Difference to server time in seconds
	 * @return string Converted input
	*/
	public function gmdate($format, $stamp=null, $GMT=null) {
		$GMT = isset($GMT) ? $GMT : gmdate("Z");
		$stamp = isset($stamp) ? ($stamp+$GMT) : (time()+$GMT);
		
		$formatArr = array(
			'd', 'D', 'j', 'l', 'N', 'S', 'w', 'z', 'W', 'F', 'm', 'M', 'n', 't', 'L', 'o', 'Y', 'y',
			'a','A', 'B', 'g', 'G', 'h', 'H', 'i', 's', 'u', 'e', 'I', 'O', 'P', 'T', 'Z', 'c', 'r', 'U'
		);
		$fullFormat = explode("|", gmdate(join("|", $formatArr), $stamp) );
		$count = count($formatArr);
		for($i=0; $i<$count; $i++) $this->format[$formatArr[$i]] = $fullFormat[$i];
		
		// Y
		list($this->jformat['Y'], $this->jformat['m'], $this->jformat['d']) = $this->gregorian_to_jalali($this->format['Y'], $this->format['m'], $this->format['d']);
		// a
		$this->jformat['a'] = ($this->format['a']=="pm") ? "ب.ظ" : "ق.ظ";
		// A
		$this->jformat['A'] = ($this->format['A']=="PM") ? "ب.ظ" : "ق.ظ";
		// B
		$this->jformat['B'] = $this->format['B'];
		// D
		switch ( strtolower($this->format['D']) ) {
			case "sat" : $this->jformat['D'] = "ش"; break; case "sun" : $this->jformat['D'] = "ی"; break;
			case "mon" : $this->jformat['D'] = "د"; break; case "tue" : $this->jformat['D'] = "س"; break;
			case "wed" : $this->jformat['D'] = "چ"; break; case "thu" : $this->jformat['D'] = "پ"; break;
			case "fri" : $this->jformat['D'] = "ج"; break;
		}
		// F
		$this->jformat['F'] = $this->ReturnMonthName($this->jformat['m']);
		// h
		$this->jformat['h'] = $this->format['h'];
		// H
		$this->jformat['H'] = $this->format['H'];
		// g
		$this->jformat['g'] = $this->format['g'];
		// G
		$this->jformat['G'] = $this->format['G'];
		// i
		$this->jformat['i'] = $this->format['i'];
		// j
		$this->jformat['j'] = $this->jformat['d'];
		// d
		$this->jformat['d'] = ($this->jformat['d'] < 10) ? "0".$this->jformat['d'] : $this->jformat['d'];
		// l
		switch ( strtolower($this->format['l']) ) {
			case "saturday" : $this->jformat['l'] = "شنبه"; break;
			case "sunday" : $this->jformat['l'] = "یکشنبه"; break;
			case "monday" : $this->jformat['l'] = "دوشنبه"; break;
			case "tuesday" : $this->jformat['l'] = "سه شنبه"; break;
			case "wednesday" : $this->jformat['l'] = "چهارشنبه"; break;
			case "thursday" : $this->jformat['l'] = "پنجشنبه"; break;
			case "friday" : $this->jformat['l'] = "جمعه"; break;
		}
		// L
		$ka = gmdate("L", (time()-31536000)); // previous Gregorian year
		$this->jformat['L'] = ($ka==1) ? 1 : 0;
		// n
		$this->jformat['n'] = $this->jformat['m'];
		// m
		$this->jformat['m'] = ($this->jformat['m'] < 10) ? "0".$this->jformat['m'] : $this->jformat['m'];
		// M
		$this->jformat['M'] = $this->jformat['F'];
		// N
		switch ( strtolower($this->format['l']) ) {
			case "saturday" : $this->jformat['N'] = 1; break;
			case "sunday" : $this->jformat['N'] = 2; break;
			case "monday" : $this->jformat['N'] = 3; break;
			case "tuesday" : $this->jformat['N'] = 4; break;
			case "wednesday" : $this->jformat['N'] = 5; break;
			case "thursday" : $this->jformat['N'] = 6; break;
			case "friday" : $this->jformat['N'] = 7; break;
		}
		// o
		$this->jformat['o'] = $this->jformat['Y'];
		// w
		$this->jformat['w'] = $this->jformat['N'] - 1;
		// t
		$this->jformat['t'] = ($this->jformat['m'] <= 6) ? 31 : 30;
		$this->jformat['t'] = ($this->jformat['m'] == 12) ? ($this->jformat['L'] == 1 ? 30 : 29) : $this->jformat['t'];
		// s
		$this->jformat['s'] = $this->format['s'];
		// S
		$this->jformat['S'] = "ام";
		// e
		$this->jformat['e'] = $this->format['e'];
		// I
		$this->jformat['I'] =$this->format['I'];
		// u
		$this->jformat['u'] = $this->format['u'];
		// U
		$this->jformat['U'] = $this->format['U'];
		// y
		$this->jformat['y'] = $this->jformat['Y']%100;
		// Z
		$this->jformat['Z'] = $this->format['Z'];
		// z
		if($this->jformat['n'] > 6) $this->jformat['z'] = 186 + (($this->jformat['n'] - 6 - 1) * 30) + $this->jformat['j'];
		else $this->jformat['z'] = (($this->jformat['n'] - 1) * 31) + $this->jformat['j'];
		// W
		$this->jformat['W'] = is_integer($this->jformat['z'] / 7) ? ($this->jformat['z'] / 7) : ($this->jformat['z'] / 7 + 1);
		// r
		$positive_z = abs(($this->jformat['Z'])/3600);
		if($positive_z > 1) {
			$z_hour = ((int) $positive_z < 10 ? "0" : "") . (int) $positive_z;
			$z_minute = (($positive_z - $z_hour) * 60 < 10 ? "0" : "") . ($positive_z - $z_hour) * 60;
		} else {
			$z_hour = "00";
			$z_minute = (($positive_z) * 60 < 10 ? "0" : "") . ($positive_z) * 60;
		}
		// P
		$this->jformat['P'] = ($this->jformat['Z'] >= 0 ? "+" : "-") . "$z_hour:$z_minute";
		// O
		$this->jformat['O'] = ($this->jformat['Z'] >= 0 ? "+" : "-") . $z_hour . $z_minute;
		// c
		$this->jformat['c'] = $this->jformat['Y'] ."-". $this->jformat['m'] ."-". $this->jformat['d'] ."-". $this->jformat['H'] ." ". $this->jformat['i'] . ":" . $this->jformat['s']. $this->jformat['P'];
		// r
		$this->jformat['r'] = $this->jformat['l'] ." ". $this->jformat['j'] ." ". $this->jformat['F'] ." ". $this->jformat['Y'] ." ". $this->jformat['h'] . ":" . $this->jformat['i'] . ":" . $this->jformat['s'] ." ". $this->jformat['O'];		
		// T
		$this->jformat['T'] = $this->format['T'];
		foreach($formatArr as $key) $format = str_replace($key, $this->jformat[$key], $format);
		return $this->translateDigits($format);
	}
	
	
	
	/**
	 * Built-in methods
	*/
	private function ReturnMonthName($monname) {
		switch ($monname) {
			case 1:	return "فروردین";	break; case 2:	return "اردیبهشت";	break; case 3:	return "خرداد";	break;
			case 4:	return "تير";	break; case 5:	return "مرداد";	break; case 6:	return "شهریور";	break;
			case 7:	return "مهر";	break; case 8:	return "آبان";	break; case 9:	return "آذر";	break;
			case 10:	return "دى";	break; case 11:	return "بهمن";	break; case 12:	return "اسفند";	break;
		}
	}
	private function div($a,$b) { return (int) ($a / $b); }
	private function translateDigits($str) {
		if($this->farsiDigits !== true) return $str;
		return str_replace(array('0','1','2','3','4','5','6','7','8','9'), array('۰','۱','۲','۳','۴','۵','۶','۷','۸','۹'), $str);
	}
	
	/**
	 * Conversion methods
	 * Thanks to Roozbeh Pournader and Mohammad Toosi for their Date Conversion program
	*/
	public function gregorian_to_jalali ($g_y, $g_m, $g_d) {
		$g_days_in_month = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		$j_days_in_month = array(31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29);
		$gy = $g_y-1600; $gm = $g_m-1; $gd = $g_d-1;
		$g_day_no = 365*$gy+$this->div($gy+3,4)-$this->div($gy+99,100)+$this->div($gy+399,400);
		for ($i=0; $i < $gm; ++$i) $g_day_no += $g_days_in_month[$i];
		if ($gm>1 && (($gy%4==0 && $gy%100!=0) || ($gy%400==0))) $g_day_no++; /* leap and after Feb */
		$g_day_no += $gd; $j_day_no = $g_day_no-79; $j_np = $this->div($j_day_no, 12053); /* 12053 = 365*33 + 32/4 */
		$j_day_no = $j_day_no % 12053; $jy = 979+33*$j_np+4*$this->div($j_day_no,1461); /* 1461 = 365*4 + 4/4 */
		$j_day_no %= 1461; if($j_day_no >= 366) { $jy += $this->div($j_day_no-1, 365); $j_day_no = ($j_day_no-1)%365; }
		for($i = 0; $i < 11 && $j_day_no >= $j_days_in_month[$i]; ++$i) $j_day_no -= $j_days_in_month[$i];
		$jm = $i+1; $jd = $j_day_no+1;
		return array($jy, $jm, $jd);
	}
	public function jalali_to_gregorian($j_y, $j_m, $j_d) {
		$g_days_in_month = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		$j_days_in_month = array(31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29);
		$jy = $j_y-979; $jm = $j_m-1; $jd = $j_d-1;
		$j_day_no = 365*$jy + $this->div($jy, 33)*8 + $this->div($jy%33+3, 4);
		for ($i=0; $i < $jm; ++$i) $j_day_no += $j_days_in_month[$i];
		$j_day_no += $jd; $g_day_no = $j_day_no+79; 
		$gy = 1600 + 400*$this->div($g_day_no, 146097); /* 146097 = 365*400 + 400/4 - 400/100 + 400/400 */
		$g_day_no = $g_day_no % 146097; $leap = true;
		if ($g_day_no >= 36525) { /* 36525 = 365*100 + 100/4 */
			$g_day_no--; $gy += 100*$this->div($g_day_no, 36524); /* 36524 = 365*100 + 100/4 - 100/100 */
			$g_day_no = $g_day_no % 36524; if ($g_day_no >= 365) $g_day_no++; else $leap = false;
		}
		$gy += 4*$this->div($g_day_no, 1461); /* 1461 = 365*4 + 4/4 */ $g_day_no %= 1461;
		if ($g_day_no >= 366) {
			$leap = false; $g_day_no--; $gy += $this->div($g_day_no, 365); $g_day_no = $g_day_no % 365;
		}
		for ($i = 0; $g_day_no >= $g_days_in_month[$i] + ($i == 1 && $leap); $i++) $g_day_no -= $g_days_in_month[$i] + ($i == 1 && $leap);
		$gm = $i+1; $gd = $g_day_no+1;
		return array($gy, $gm, $gd);
	}
	
	/**
	 * Backward compatibility
	*/
	public function jdate($format, $stamp=null, $GMT=null) {
		return $this->date($format, $stamp, $GMT);
	}
}


/**
 * Backward compatibility.
*/
Class Calendar extends jCalendar { }


?>